#include "main.h"

using namespace std;

string code_HPDA_TIMESTAMP = "HPDA_TIMESTAMP";
string code_start_job_timestamp = "JobCurrentStartDate";
string code_completion_timestamp = "CompletionDate";
string code_File_found_on_server = "File_found_on_server";
string code_Requested_files = "Requested_files";
string code_HPDA_RANK_MONITORING = "HPDA_RANK_MONITORING";
string code_GlobalJobId = "GlobalJobId";
string code_RemoteUserCpu = "RemoteUserCpu";
string code_RemoteSysCpu = "RemoteSysCpu";
string code_RequestCpus = "RequestCpus";
string code_NetworkInputMb = "NetworkInputMb";
string code_LastRemoteHost = "LastRemoteHost";
string code_getIP = "StartdPrincipal";
string code_InputFiles_tmp = "InputFiles_tmp";

string job_id ="";
string CompletionDate = "";
string JobCurrentStartDate = "";
string FileFoundOnServer = "";
string RequestedFiles = "";
string Rank = "";
string HPDA_REQUIREMENT = "";
string RequestCpus = "";
string RemoteSysCpu = "";
string RemoteUserCpu = "";
string NetworkInputMb = "";
string RemoteHost = "";
string last_remote_ip = "";
string InputFiles_tmp = "";

int get_data_from_condor(){
    bool catch_empty_line = true;
    do {
        input ="";
        // read from terminal / get DATA from HTCondor
        getline(cin, input);
        // if input equals nothing set termination signal
        if (input == ""){
            if(catch_empty_line){
                catch_empty_line = false;
            }
            else{
                input = termination_signal;
                char small_buffer[input.size()];
                strncpy(small_buffer, input.c_str(), sizeof(small_buffer));
                send(client, small_buffer, sizeof(small_buffer), 0);
            }
        }
        else if (input.find(code_Input_Files) == 0){
                requested_files = input + "\n";
        }
        else if (input.find(code_directory) == 0){
                absolute_path = input + "\n";
        }
        else if(input.find(code_HPDA_TIMESTAMP) == 0){
                time_stamp = input + "\n";
        }        
        else if(input.find(code_start_job_timestamp) == 0){
                JobCurrentStartDate = input + "\n";
        }
        else if(input.find(code_completion_timestamp) == 0){
                CompletionDate = input + "\n";
        }
        else if(input.find(code_File_found_on_server) == 0){
                FileFoundOnServer = input + "\n";
        }
        else if(input.find(code_Requested_files) == 0){
                RequestedFiles = input + "\n";
        }
        else if(input.find(code_HPDA_RANK_MONITORING) == 0){
                Rank = input + "\n";
        }
	    else if(input.find(code_GlobalJobId) == 0){
                job_id = input + "\n";
        }
	    else if(input.find(code_RemoteUserCpu) == 0){
                RemoteUserCpu = input + "\n";
        }
	    else if(input.find(code_RemoteSysCpu) == 0){
                RemoteSysCpu = input + "\n";
        }
	    else if(input.find(code_RequestCpus) == 0){
		        RequestCpus = input + "\n";
        }
	    else if(input.find(code_HPDA_REQUIREMENT) == 0){
                HPDA_REQUIREMENT = input + "\n";
        }
	    else if(input.find(code_NetworkInputMb) == 0){
                NetworkInputMb = input + "\n";
        }
        else if(input.find(code_LastRemoteHost) == 0){
                RemoteHost = input + "\n";
        }
        else if(input.find(code_getIP) == 0){
                last_remote_ip = input + "\n";
        }
        else if(input.find(code_InputFiles_tmp) == 0){
                InputFiles_tmp = input + "\n";
        }
    }while (input != termination_signal);

    return 0;

}

int main() {

    if (get_data_from_condor() == -1){
        return -1;
    }
    if (check_given_input_files() == -1){
        return -1;
    }
    requested_files = requested_files + "END_OF_REQUESTED_FILES\n";
    InputFiles_tmp = InputFiles_tmp + "END_OF_REQUESTED_FILES\n";
    // open connection
    client = open_connection(portNum);
    if (client == -1){
        return (-1);
    }
    //open private connection port for every request
    private_port = private_client_server_connection_get_port();
    if (private_port == -1){
        close_connection();
        return -1;
    }
        if (close_connection() != 0){
            return -1;
        }
        client = open_connection(private_port);
        if (client == -1){
            return (-1);
        }
        //send data via connection
        if (send("FINALIZE\n") != 0){
            close_connection();
            return (-1);
        }
        if (send(requested_files) != 0){
            close_connection();
            return (-1);
        }
        if (send(RemoteHost) != 0){
            close_connection();
            return (-1);
        }
        if (send(time_stamp) != 0){
            close_connection();
            return (-1);
        }
        if (send(job_id) != 0){
            close_connection();
            return (-1);
        }
        if (send(CompletionDate) != 0){
            close_connection();
            return (-1);
        }
        if (send(JobCurrentStartDate) != 0){
            close_connection();
            return (-1);
        }
        if (send(FileFoundOnServer) != 0){
            close_connection();
            return (-1);
        }
        if (send(RequestedFiles) != 0){
            close_connection();
            return (-1);
        }
        if (send(Rank) != 0){
            close_connection();
            return (-1);
        }
        if (send(RequestCpus) != 0){
            close_connection();
            return (-1);
        }
        if (send(RemoteSysCpu) != 0){
            close_connection();
            return (-1);
        }
        if (send(RemoteUserCpu) != 0){
            close_connection();
            return (-1);
        }
        if (send(HPDA_REQUIREMENT) != 0){
            close_connection();
            return (-1);
        }
        if (NetworkInputMb != ""){
            if (send(NetworkInputMb) != 0){
                close_connection();
                return (-1);
            }
        }
        if (send(last_remote_ip) != 0){
            close_connection();
            return (-1);
        }
        if (send(InputFiles_tmp) != 0){
            close_connection();
            return (-1);
        }
        if (send(termination_signal) != 0){
            close_connection();
            return (-1);
        }
	return 0; // always return 0 => No update of classads needed in finalize step
}

