#include "main.h"
bool update = false;
string code_HPDA_TIMESTAMP = "HPDA_TIMESTAMP";

int send_timestamp(){
    char small_buffer_files[time_stamp.size()];
    strncpy(small_buffer_files, time_stamp.c_str(), sizeof(small_buffer_files));
    send(client, small_buffer_files, sizeof(small_buffer_files), 0);
    return 0;
}

int get_data_from_condor(){
    do {
        input ="";
        // read from terminal / get DATA from HTCondor
        getline(cin, input);

        // if input equals nothing set termination signal
        if (input == ""){
            input = termination_signal;
            char small_buffer[input.size()];
            strncpy(small_buffer, input.c_str(), sizeof(small_buffer));
            send(client, small_buffer, sizeof(small_buffer), 0);
        }
        else{
            input += "\n";
            //find input files and transfer them to server
            if (input.find(code_Input_Files) == 0){
                // small_buffer used to cut of string at end -> if buffer would be used there would be plenty of /x00
                requested_files = input;
            }
            else if(input.find(code_HPDA_TIMESTAMP) == 0){
                time_stamp = "\n" + input;
            }
            else if (input.find(code_directory) == 0){
                absolute_path += input;
            }
            else if (input.find("JobStatus = 1") == 0){
                update = true;
            }
            data += input;
        }
    }while (input != termination_signal);
    if (data == ""){
        cout << "Header not found / no valid input" << endl;
        return -1;
    }
    else if (requested_files == ""){
        cout << "Requested files not found!" << endl;
        return -1;
    }

    return 0;

}

int main() {

    if (get_data_from_condor() == -1){
        return -1;
    }
    if (!update){
        // if job is not idle no further interaction is desired
        return 0;
    }
    //update hooks request only updated ClassAds
    data ="";
    if (check_given_input_files() == -1){
        return -1;
    }
    // open connection
    client = open_connection(portNum);
    if (client == -1){
        return (-1);
    }
    //open private connection port for every request
    private_port = private_client_server_connection_get_port();
    if ( private_port == -1){
        close_connection();
        return -1;
    }
    if (close_connection() != 0){
        return -1;
    }
    client = open_connection(private_port);
    if (client == -1){
        return (-1);
    }
    //process data via connection
    if (send(requested_files) != 0){
        close_connection();
        return (-1);
    }
    if (send(time_stamp) != 0){
        close_connection();
        return (-1);
    }
    if (send(termination_signal) != 0){
        close_connection();
        return (-1);
    }
    if (receive_information() != 0){
        close_connection();
        return -1;
    }
    //close connection
    return (close_connection());
}
