#include <iostream>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <algorithm>
#include <string>
#include <fstream>


using namespace std;
/* -------------- INITIALIZING VARIABLES -------------- */
int client; // socket file descriptors
int portNum = 8889;
int private_port;
int bufsize = 1024; // buffer size
char ip[] = "127.0.0.1"; // Server IP
bool isExit = false; // var fo continue infinitly
string termination_signal = "END111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111";
string data ="";
bool end_of_header = false;
string input = "";
string requested_files = "";
string time_stamp = "";
string tmp = "";
string absolute_path = "";
string code_Input_Files = "Input_Files";
string code_HPDA_RANK = "HPDA_RANK";
string code_HPDA_REQUIREMENT = "HPDA_REQUIREMENT";
string code_Rank = "RANK";
string code_directory = "Iwd";

int open_connection(int port){
    /* Structure describing an Internet socket address. */
    struct sockaddr_in server_addr;

     /* ---------- ESTABLISHING SOCKET CONNECTION ----------*/
     client = socket(AF_INET, SOCK_STREAM, 0);
     // client = -1 on fail
     if (client < 0) {
        cout << "\n  !Error establishing socket..." << endl;
        exit(-1);
     }

     server_addr.sin_family = AF_INET;
     server_addr.sin_port = htons(port);
     /*
     * This function converts an Internet address (either IPv4 or IPv6)
     * from presentation (textual) to network (binary) format.
     * If the comunication is on the same machine, you can comment this line.
     */
     inet_pton(AF_INET, ip, &server_addr.sin_addr);

     /* ---------- CONNECTING THE SOCKET ---------- */

    if (connect(client, (struct sockaddr *) &server_addr, sizeof(server_addr)) < 0){
        cout << "\n !Error while connecting to server!";
        return (-1);
        // No output allowed, except ClassAD
        //cout << "\n Connection to the server port number: " << portNum << endl;
    }
    else {
        // No output allowed, except ClassAD
        return (client);
    }
}

int private_client_server_connection_get_port(){
    int pid =  getpid();

    //get size for buffer
    int number_of_digits = 0;
    do {
        ++number_of_digits;
        pid /= 10;
    } while (pid);

    //set pid again
    pid =  getpid();
    char small_buffer[number_of_digits];
    sprintf(small_buffer, "%d", pid);
    //send pid as identfier -> every process should have it's own port
    send(client, small_buffer, sizeof(small_buffer), 0);
    char buffer[bufsize];  // buffer to transmit
    memset(buffer, '\0', bufsize);
    if(!( recv(client, buffer, bufsize, 0)))
        {
            //Failed to Recieve Data
            cout << "Failed recieving data!" << endl;
            return -1;
        }
    else if(buffer[0] == '\0')
        {
             cout << "Communication broke unexpected!" << endl;
             return -1;
        }
    else{
            string port_name = buffer;
            if (pid == atoi((port_name.substr(0, port_name.find(':')).c_str()))){
                return (atoi( (port_name.erase(0, port_name.find(':') + 1)).c_str()));
            }
            else {
                cout << "wrong pid" << endl;
            }

        }
    return -1;
}

int send(string string_to_send){
    char small_buffer_files[string_to_send.size()];
    strncpy(small_buffer_files, string_to_send.c_str(), sizeof(small_buffer_files));
    send(client, small_buffer_files, sizeof(small_buffer_files), 0);
    return 0;
}

int receive_information(){
    char buffer[bufsize];  // buffer to transmit
    char END[termination_signal.size() + 1];
    strncpy(END, termination_signal.c_str(), sizeof(END));
    END[termination_signal.size() + 1] = '\0';
    //Recieved Data!!
    // No output allowed, except ClassAD
    do {
        // clear buffer
        memset(buffer, '\0', bufsize);
        //reciev new entries to buffer
        recv(client, buffer, bufsize, 0);
        //check for terminate signal
        if (strstr(buffer, END)){
            // add last buffer and cut of termination_signal -> sometimes two lines are received as one...
            tmp = buffer;
            if (tmp.find(termination_signal) != 0 and (buffer[0] == '1' or buffer[0] == '0')){
                tmp = tmp.erase(0, 1);
            }
            data += tmp;
            data = data.substr(0, data.size()-(termination_signal.size()));
            //remove empty lines
            string double_n = "\n\n";
            size_t empty_line = data.find( double_n);
            while (empty_line != string::npos){
                data.replace(empty_line, double_n.size() , "\n");
                empty_line = data.find(double_n);
            }
            cout << data;
            return 0;
        }
        else if(buffer[0] == '\0'){
            cout << "Communication broke unexpected!" << endl;
            return -1;
        }
        else{
            tmp = buffer;
            if (buffer[0] == '1' or buffer[0] == '0'){
                tmp = tmp.erase(0,1);
            }
            data += tmp;
	    if (buffer[0] == '1'){
                data += "\n";
            }
        }
    }while (true);
    return 0;
}


int check_given_input_files(){
    // check if input file is a file list
    if ((requested_files != "") && (requested_files.find(",") == string::npos) && (requested_files.find(code_Input_Files + " = \"root://") != 0)){
        try{
            //reduce requested_files to name of file list -> cut at the start the string "to_cut" + at the end two chars, which are expected to be "/"\n"
            string to_cut_input_files = code_Input_Files + " = \"";
            requested_files = requested_files.substr(to_cut_input_files.size(), requested_files.size()-( 2 + to_cut_input_files.size() ));
            if (requested_files.at(0) != '/'){
                string to_cut_iwd = code_directory + " = \"";
                absolute_path = absolute_path.substr(to_cut_iwd.size(), absolute_path.size()-( 2 + to_cut_iwd.size() ));
                requested_files = absolute_path + '/' + requested_files;
            }
            // cast string to char
            char small_buffer_file_list[requested_files.size() + 1];
            strncpy(small_buffer_file_list, requested_files.c_str(), sizeof(small_buffer_file_list));
            small_buffer_file_list[requested_files.size() + 1] = '\0';
            //read input
            ifstream in(small_buffer_file_list);
            istreambuf_iterator<char> eos;
            string contents((istreambuf_iterator<char>(in)), eos);
            in.close();
            requested_files = to_cut_input_files + contents.substr(0, contents.size() - 1)  + "\"";

        }catch(exception e){
            cout << "Failed reading input list from file!" << endl;
            return -1;
        }
    }
    return 0;
}

int close_connection(){
    /* ---------------- CLOSE CALL -------------
    *No output allowed, except ClassAD
    */
    return (close(client));
}

