from unittest import TestCase
from navix.logging import *
from tests.settings_for_test import SettingsForTesting as Settings

from navix.reply_generator import ComputeAndGenerateReply


class TestComputeAndGenerateReply(TestCase):
    maxDiff = None

    def setUp(self):
        # log file path
        log_file_s = 'NaviX_start_error.log'

        # create logger
        start_log = logging.getLogger(log_file_s)
        start_log.setLevel(logging.DEBUG)
        settings = Settings()
        log = Logging()

        self.thread_num = "TEST"
        self.settings = settings
        self.logger = log.queue_logging

        self.server_dict = dict()

    def test_compute_generate_reply(self):
        data = "Non sense"
        generator = ComputeAndGenerateReply(data, self.logger, self.thread_num, self.settings)
        with self.assertRaises(ValueError):
            reply = generator.compute_generate_reply()
        del generator
        data = ("\"root://eospublic.cern.ch//no_file\"")
        generator = ComputeAndGenerateReply(data, self.logger, self.thread_num, self.settings)
        reply = generator.compute_generate_reply()
        expected_reply = ["HPDA_RANK = (0)", "HPDA_TIMESTAMP = \"", "HPDA_REQUIREMENT = (True)",
                          'InputFiles_tmp = \"']
        for index, line in enumerate(reply.splitlines()):
            self.assertEqual(expected_reply[index], line[:len(expected_reply[index])])



        # TODO Test cached file => need server with fixed testfile !
        # del generator
        # data = ("\"root://eospublic.cern.ch//eos/opendata/cms/Run2012B/DoubleMuParked/AOD/22Jan2013-v1/310000/"
        #         + "FE5A353C-9B6F-E211-8B20-00259073E398.root\"")
        # generator = ComputeAndGenerateReply(data, self.logger, self.thread_num, self.settings)
        # reply = generator.compute_generate_reply()
        # print(reply)